function U = get_initial_subspace(n,r)
%
%  U = get_initial_subspace(n,r)
%
% Computes an orthogonal basis for the n x r matrix generated by
% putting all ones in the first column, ones in every other entry
% of the second column, ones in every third entry of the third
% column and so on. The first entry is always one.

%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, see <http://www.gnu.org/licenses/>.
%
% Copyright (C) Jens Saak, Martin Koehler, Peter Benner and others 
%               2009-2020
if nargin~=2
    error('number of rows n and columns r are mandatory!');
end
V = zeros(n,r);

for j = 1:r
    V(1:j:n,j) = 1.0;
end

[U, ~] = qr(V,0);